<?php
// ----------------------------------------------------------------------------
// ___            ___  __  __________   _       _  ________
// \  \          /  / |__||  _______ | | |     | ||  ______|
//  \  \        /  /   __ | |      | | | |     | || |
//   \  \      /  /   |  || |______|_| | |     | || |______
//    \  \    /  /    |  || |   \  \   | |     | ||______  |
//     \  \  /  /     |  || |    \  \  | |     | |       | |
//      \  \/  /      |  || |     \  \ | |_____| | ______| |
//       \____/       |__||_|      \__\|_________||________|
//           _________  ________  _______   __  ____    __  __________
//          |  _______||  ____  || _____ \ |__||    \  |  ||  ________|
//          | |        | |    | |||     \ \ __ |  \  \ |  || |
//          | |        | |    | |||     | ||  ||  |\  \|  || |  ______
//          | |        | |    | |||     | ||  ||  | \  |  || | |____  |
//          | |_______ | |____| |||_____/ /|  ||  |  \    || |______| |
//          |_________||________||_______/ |__||__|   \___||__________|
//
// ************************************************************************************//
// * By The Fury
//
//* Sicherheits - Restorefunktion
//* Diese Datei (backup.php) stellt Funktionen und Methoden um das Backup einzulesen!
//* Nur nutzbar mit safe_mode off !! 
//* Idee und Umsetzung: The Fury
//* Greetz fly out to Black Angle ,rellek, zero, onkel heinz, The Pain, Frank  & all others
// ************************************************************************************//
// * ~Date:  08.12.2009  14:32:23
// * ~Autor: The Fury
// ************************************************************************************//

/** Fehlervariable leeren **/
$fehler = "";

// Wenn der safe_mode on steht, dann kann nicht das Backup eingespielt werden - aufgrund der MAX_EXECUTION_TIME!!
if (ini_get('safe_mode') == '1'){
	$fehler .= "Mit safe_mode on kann kein Backup eingespielt werden!";
}

// Hier weitermachen, wenn safe_mode off steht

if(!file_exists("./lib/config.inc.php")) {$fehler .= "Lade bitte die acp/lib/config.inc.php in den Ordner acp/lib/<br>";}
if(file_exists("./lib/RestoreMD5.lock")) {$fehler .= "Die Restorefunktion nur einmal ausf&uuml;hren! Ansonsten RestoreMD5.lock l&ouml;schen!<br>";}
if(!file_exists("bb".$n."_users.sql")) {$fehler .= "Lade bitte die bb".$n."_users.sql in den Ordner acp<br>";}
if(!file_exists("md5instbackupsql.php")) {$fehler .= "Lade bitte die acp/md5instbackupsql.php in den Ordner acp/<br>";}
if(!file_exists("sicherheits_verschluesselung.php")) {$fehler .= "Lade bitte die sicherheits_verschluesselung.php in den Ordner acp<br>";}

  @chmod("bb".$n."_users.sql", 0777);
  if(!is_writeable("bb".$n."_users.sql")){
	$fehler .= "Gebe der Datei bb".$n."_users.sql die Rechte 777!<br>";
	}

/** Konfiguration vom WBB einlesen **/
require("./lib/config.inc.php");

/** Datenbankverbindung aufbauen **/
$db = mysql_connect($sqlhost, $sqluser, $sqlpassword) or $fehler .= "Konnte DB-Server nicht erreichen";

/** Datenbank ausw&auml;hlen **/
mysql_select_db($sqldb);

/** unset wird wieder gesetzt um zu sch&uuml;tzen **/
unset ($sqldb);

/** Variable Schritt wird 0 gesetzt um bei 0 anzufangen **/
$schritt = 0;

/** Variable schritt auf get-var holen und immer einen + z&auml;hlen **/
if ($_GET['schritt'] != ""){
$schritt = $_GET['schritt'];
$schritt ++;
}

if ($_GET['sicher'] != ""){
$sicher = $_GET['sicher'];
}

if ($_GET['installation'] != ""){
	$auswahl = $_GET['installation'];
}

echo '<?xml version="1.0" encoding="windows-1252"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml" dir="ltr" lang="de" xml:lang="de"><head><title>Sicherheitsverschl&uuml;sselung by The Fury V.2.0</title><link rel="stylesheet" href="css/main.css" />';
?>
<style type="text/css">
 <!--
INPUT {
 FONT-SIZE: 12px;
 FONT-FAMILY: Tahoma,Helvetica;
 COLOR: #000000;
 BACKGROUND-COLOR: #CFCFCF;

 border-top-width : 1px;
 border-right-width : 1px;
 border-bottom-width : 1px;
 border-left-width : 1px;
 text-indent : 2px;
}
-->
</style>
<?php
echo '</head><body>';
echo '<table align="center" width="600"><tr><td align="center"><img src="images/acp-logo.gif" border="0" alt="" /></td></tr><tr><td align="center"><br><br>';

/** Wenn die Variable $fehler nicht leer ist, soll folgender Fehler ausgegeben werden **/
if ($fehler != ""){
?>
<table align="center" width="600" cellpadding="4" cellspacing="1" border="0" class="tblborder">
 <tr>
  <td align="center" colspan="2" class="tblhead">Bei der Installation ist ein Fehler aufgetreten.</td>
 </tr>
 <tr>
  <td align="center" colspan="2" class="firstrow">
   <br><br><u>Fehlermeldung:</u><br><?php echo $fehler; ?><br><br>
  </td>
 </tr>
 <tr>
  <td align="center" class="secondrow" width="50%"><input type="button" value="Erneut versuchen" onclick="location='backup.php'"></td>
  <td align="center" class="secondrow" width="50%"><input type="button" value="zur Startseite" onclick="location='../index.php'"></td>
 </tr>
</table>
<?php
}

/** Wenn oben genannte Variable leer ist - weitermachen **/
if ($fehler == ""){
	if($schritt == 0){
	
	?>
<table cellpadding="4" cellspacing="1" border="0" class="tblborder">
<tr>
 <td align="center" colspan="2" class="tblhead"> Restorefunktion - Auswahl</td>
</tr>
<tr>
 <td align="center" colspan="2" class="firstrow"><br><b>M&ouml;chtest Du die Sicherheitsverschl&uuml;sselung installieren, oder das Backup einspielen?</b><br><br></td>
</tr>
<tr>
 <td align="center" class="secondrow" width="50%"><input type="button" value="Installation" onclick="location='backup.php?schritt=0&installation=install'"></td>
 <td align="center" class="secondrow" width="50%"><input type="button" value="Tabellenwiederherstellung" onclick="location='backup.php?schritt=0&installation=restore'"></td>
</tr>
</table>

<?php
}

if($auswahl == "install"){
	Header("Location: sicherheits_verschluesselung.php");
exit(); 
}

/** Wenn die Installation gestartet wird, soll folgender Inhalt angezeigt werden **/
if ($schritt == 1 and $auswahl == "restore"){
?>
<table cellpadding="4" cellspacing="1" border="0" class="tblborder">
<tr>
 <td align="center" colspan="2" class="tblhead"> Restorefunktion - Schritt 1 / 3</td>
</tr>
<tr>
 <td align="center" colspan="2" class="firstrow"><br><b>M&ouml;chtest Du  die<br><i>Restorefunktion von der Sicherheits-Verschl&uuml;sselung V.2.0</i><br>made by The Fury<br>Installation ausf&uuml;hren?</b><br><br></td>
</tr>
<tr>
 <td align="center" class="secondrow" width="50%"><input type="button" value="JA" onclick="location='backup.php?schritt=0&sicher=ja'"></td>
 <td align="center" class="secondrow" width="50%"><input type="button" value="NEIN" onclick="location='backup.php?schritt=0&sicher=nein'"></td>
</tr>
</table>
<?php
}
if ($schritt == 1 and $sicher== "ja"){
?>

<table cellpadding="4" cellspacing="1" border="0" class="tblborder">
<tr>
 <td align="center" colspan="2" class="tblhead"> Restorefunktion - Schritt 2 / 3</td>
</tr>
<tr>
 <td align="center" colspan="2" class="firstrow"><br><b>Wenn du nun best&auml;tigst, wird die Verschl&uuml;sselung r&uuml;ckg&auml;ngig gemacht!<br>Vergiss bitte nicht, die Installationanleitung r&uuml;ckw&auml;rts durchzugehen!</b><br><br></td>
</tr>
<tr>
 <td align="center" class="secondrow" width="50%"><input type="button" value="JA" onclick="location='backup.php?schritt=1&sicher=ja'"></td>
 <td align="center" class="secondrow" width="50%"><input type="button" value="NEIN" onclick="location='backup.php?schritt=1&sicher=nein'"></td>
</tr>
</table>

<?php
}

if ($schritt == 1 and $sicher == "nein"){
	?>
		<table cellpadding="4" cellspacing="1" border="0" class="tblborder">
<tr>
 <td align="center" colspan="2" class="tblhead"> Restorefunktion - Abbruch</td>
</tr>
<tr>
 <td align="center" colspan="2" class="firstrow"><br><b>Die Installation wurde abgebrochen und das Backup wurde <u>nicht</u> eingespielt und wiederhergestellt!<br><br></td>
</tr>
<tr>
 <td align="center" colspan="2" class="firstrow"><br>Falls es Fragen gibt, sende mir eine E-Mail (siehe Anleitung) oder direkt im Forum.<br><br></td>
</tr>
<tr>
 <td align="center" colspan="2" class="secondrow"><input type="button" value="zur Startseite" onclick="location='../index.php'"></td>
</tr>
</table>
<?php
}

	if ($schritt == 2 and $sicher == "ja"){


  // Setze die maximale Ausfhrzeit hoch, falls das Backup gro ist und daher lange braucht
  set_time_limit(300);
  // datei ffnen
  $fp = @fopen("bb".$n."_users.sql", "r") or $fehler .= "Kann die bb".$n."_users.sql nicht &ouml;ffnen!";
  // datei zeilenweise auslesen
  while($line = fgets($fp, 4096)){
  	set_time_limit(45);
  mysql_query($line);
  }
// datei schliessen
fclose($fp);


?>
<table cellpadding="4" cellspacing="1" border="0" class="tblborder">
<tr>
 <td align="center" colspan="2" class="tblhead"> Restorefunktion</td>
</tr>
<tr>
 <td align="center" colspan="2" class="firstrow"><br><b><i> Restorefunktion von Sicherheits-Verschl&uuml;sselung V.2.0</i><br>made by The Fury<br>erfolgreich durchgef&uuml;hrt!</b><br><br></td>
</tr>
<tr>
 <td align="center" colspan="2" class="firstrow"><br>Installationsdatei und Restorefunktion jetzt l&ouml;schen?<br><br>Hinweis, das nicht-l&ouml;schen von Installationsdateien und der Restorefunktion kann unter umst&auml;nden Sicherheitsrisiken f&uuml;r das ganze Board verursachen.<br>Es wird empfohlen die Dateien "acp/lib/encryption.php", "sicherheits_verschluesselung.php", "bb".$n."_users", "backup.php", "md5instbackupsql.php" manuell umzubenennen oder sie zu l&ouml;schen!!<br><br></td>
</tr>
<tr>
 <td align="center" class="secondrow" width="50%"><input type="button" value="JA" onclick="location='backup.php?schritt=2&sicher=ja&ilock=ja'"></td>
 <td align="center" class="secondrow" width="50%"><input type="button" value="NEIN" onclick="location='backup.php?schritt=2&sicher=nein&ilock=nein'"></td>
</tr>
</table>
<?php
}

if ($schritt == 2 and $sicher == "nein"){
	?>
			<table cellpadding="4" cellspacing="1" border="0" class="tblborder">
<tr>
 <td align="center" colspan="2" class="tblhead"> Restorefunktion - Abbruch</td>
</tr>
<tr>
 <td align="center" colspan="2" class="firstrow"><br><b>Die Installation wurde abgebrochen und das Backup <u>wurde </u> eingespielt und wiederhergestellt! Die Dateien wurden allerdings nicht gel&ouml;scht! L&ouml;sche also "encryption.php", "sicherheits_verschluesselung.php", "bb".$n."_users", "backup.php", "md5instbackupsql.php"!!<br><br></td>
</tr>
<tr>
 <td align="center" colspan="2" class="firstrow"><br>Falls es Fragen gibt, sende mir eine E-Mail (siehe Anleitung) oder direkt im Forum.<br><br></td>
</tr>
<tr>
 <td align="center" colspan="2" class="secondrow"><input type="button" value="zur Startseite" onclick="location='../index.php'"></td>
</tr>
</table>
<?php
}
if ($schritt == 3 and $sicher == "ja"){
	if (!@unlink("sicherheits_verschluesselung.php")){
 $fehler .= "sicherheits_verschluesselung.php- Datei konnte nicht gel&ouml;uml;scht werden!<br>";
 }
 if (!@unlink("backup.php")){
 $fehler .= "backup.php- Datei konnte nicht gel&ouml;uml;scht werden!<br>";
 }
 if (!@unlink("bb".$n."_users.sql")){
 $fehler .= "bb".$n."_users.sql- Datei konnte nicht gel&ouml;uml;scht werden!<br>";
 }
 if (!@unlink("md5instbackupsql.php")){
 $fehler .= "md5instbackupsql.php- Datei konnte nicht gel&ouml;uml;scht werden!<br>";
 }
  if (!@unlink("./lib/encryption.php")){
 $fehler .= "encryption.php- Datei konnte nicht gel&ouml;uml;scht werden!<br>";
 }

 

	?>
	<table cellpadding="4" cellspacing="1" border="0" class="tblborder">
<tr>
 <td align="center" colspan="2" class="tblhead"> Restorefunktion - Ende</td>
</tr>
<tr>
 <td align="center" colspan="2" class="firstrow"><br><b>Installation wurde nun beendet und jetzt bitte die Anleitung r&uuml;ckw&auml;rts durchgehen und "encryption.php" l&ouml;schen!<br><br></td>
</tr>
<tr>
 <td align="center" colspan="2" class="firstrow"><br>Falls es Fragen gibt, sende mir eine E-Mail (siehe Anleitung) oder direkt im Forum.<br><br></td>
</tr>
<tr>
 <td align="center" colspan="2" class="secondrow"><input type="button" value="zur Startseite" onclick="location='../index.php'"></td>
</tr>
</table>

<?php
 $fp = fopen("./lib/RestoreMD5.lock", "w");
fputs($fp, "Restorefunktion Sicherheitsverschluesselung by The Fury V.2.0\n");
fputs($fp, "made by The Fury\n");
fputs($fp, "erfolgreich durchgefhrt!\n");
fclose($fp);
}


if ($schritt == 3 and $sicher == "nein"){

?>
	<table cellpadding="4" cellspacing="1" border="0" class="tblborder">
<tr>
 <td align="center" colspan="2" class="tblhead"> Restorefunktion - Ende</td>
</tr>
<tr>
 <td align="center" colspan="2" class="firstrow"><br><b>Installation wurde nun beendet und jetzt bitte die Anleitung r&uuml;ckw&auml;rts durchgehen und "encryption.php", "sicherheits_verschluesselung.php", "bb".$n."_users", "backup.php", "md5instbackupsql.php" l&ouml;schen!<br><br></td>
</tr>
<tr>
 <td align="center" colspan="2" class="firstrow"><br>Falls es Fragen gibt, sende mir eine E-Mail (siehe Anleitung) oder direkt im Forum.<br><br></td>
</tr>
<tr>
 <td align="center" colspan="2" class="secondrow"><input type="button" value="zur Startseite" onclick="location='../index.php'"></td>
</tr>
</table>
<?php
	 $fp = fopen("./lib/RestoreMD5.lock", "w");
fputs($fp, "Restorefunktion Sicherheitsverschluesselung by The Fury V.2.0\n");
fputs($fp, "made by The Fury\n");
fputs($fp, "erfolgreich durchgefhrt!\n");
fclose($fp);
}

}

echo '<br><br><br><br><br>';
 
echo '<table class="tableinborder" align="center" border="0" cellpadding="4" cellspacing="1">';
echo '<tbody><tr><td class="tablea" align="center"><span class="smallfont">';
echo '<a href="http://www.radiosunlight.de" target="_blank"><br> Sicherheitsverschl&uuml;sselung Version 2.0 by The Fury &copy; 2008-2009 </span></td>';
echo '</tr></tbody></table><br></body></html>';
?>




